Makefile 76.4 KB
Newer Older
1
# SPDX-License-Identifier: GPL-2.0+
2

T
Tom Rini 已提交
3
VERSION = 2021
T
Tom Rini 已提交
4
PATCHLEVEL = 04
W
Wolfgang Denk 已提交
5
SUBLEVEL =
T
Tom Rini 已提交
6
EXTRAVERSION = -rc4
7
NAME =
8

9 10 11 12 13 14
# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

15 16 17 18
# o Do not use make's built-in rules and variables
#   (this increases performance and avoids hard-to-debug behaviour);
# o Look for make include files relative to root of kernel src
MAKEFLAGS += -rR --include-dir=$(CURDIR)
19

20
# Determine target architecture for the sandbox
21
include include/host_arch.h
22 23 24 25 26
ifeq ("", "$(CROSS_COMPILE)")
  MK_ARCH="${shell uname -m}"
else
  MK_ARCH="${shell echo $(CROSS_COMPILE) | sed -n 's/^\s*\([^\/]*\/\)*\([^-]*\)-\S*/\2/p'}"
endif
27 28 29 30 31 32 33
unexport HOST_ARCH
ifeq ("x86_64", $(MK_ARCH))
  export HOST_ARCH=$(HOST_ARCH_X86_64)
else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
  export HOST_ARCH=$(HOST_ARCH_X86)
else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
  export HOST_ARCH=$(HOST_ARCH_AARCH64)
34
else ifneq (,$(findstring $(MK_ARCH), "arm" "armv7" "armv7l"))
35 36 37 38 39 40 41 42
  export HOST_ARCH=$(HOST_ARCH_ARM)
else ifeq ("riscv32", $(MK_ARCH))
  export HOST_ARCH=$(HOST_ARCH_RISCV32)
else ifeq ("riscv64", $(MK_ARCH))
  export HOST_ARCH=$(HOST_ARCH_RISCV64)
endif
undefine MK_ARCH

43 44 45 46 47 48
# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

49 50 51
# Avoid interference with shell env settings
unexport GREP_OPTIONS

52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67
# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.
#
91 92 93 94 95 96 97 98 99 100
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

101 102 103 104 105 106 107
ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif
108

109 110 111 112 113 114
# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(filter 4.%,$(MAKE_VERSION)),)	# make-4
ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
  quiet=silent_
115
endif
116 117 118
else					# make-3.8x
ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
  quiet=silent_
119 120 121
endif
endif

122
export quiet Q KBUILD_VERBOSE
123

124 125 126 127 128
# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
129
#
130 131 132 133 134
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
135
#
136 137 138 139 140 141
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)
142

143 144
# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
145
ifeq ("$(origin O)", "command line")
146 147 148 149 150 151 152 153 154 155 156 157 158 159
  KBUILD_OUTPUT := $(O)
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

# Cancel implicit rules on top Makefile
$(CURDIR)/Makefile Makefile: ;

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
160 161
KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
								&& /bin/pwd)
162
$(if $(KBUILD_OUTPUT),, \
163
     $(error failed to create output directory "$(saved-output)"))
164 165 166 167 168 169 170

PHONY += $(MAKECMDGOALS) sub-make

$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
	@:

sub-make: FORCE
171 172
	$(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
	-f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
173 174 175 176 177 178 179 180 181

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

182 183 184 185 186 187 188 189 190 191 192 193
# Do not print "Entering directory ...",
# but we want to display it when entering to the output directory
# so that IDEs/editors are able to understand relative filenames.
MAKEFLAGS += --no-print-directory

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
194
# See the file "doc/sparse.txt" for more details, including
195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214
# where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif

ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

215 216
# If building an external module we do not care about the all: rule
# but instead _all depend on modules
217
PHONY += all
218
ifeq ($(KBUILD_EXTMOD),)
219
_all: all
220
else
221
_all: modules
222
endif
223

224 225 226 227 228 229 230 231 232 233 234 235
ifeq ($(KBUILD_SRC),)
        # building in the source tree
        srctree := .
else
        ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(KBUILD_SRC)
        endif
endif
objtree		:= .
236 237 238 239 240 241 242
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH

W
Wolfgang Denk 已提交
243 244 245
# Make sure CDPATH settings don't interfere
unexport CDPATH

W
wdenk 已提交
246 247 248
#########################################################################

HOSTARCH := $(shell uname -m | \
G
Graeme Russ 已提交
249
	sed -e s/i.86/x86/ \
W
wdenk 已提交
250 251 252
	    -e s/sun4u/sparc64/ \
	    -e s/arm.*/arm/ \
	    -e s/sa110/arm/ \
K
Kumar Gala 已提交
253 254
	    -e s/ppc64/powerpc/ \
	    -e s/ppc/powerpc/ \
N
Nobuhiro Iwamatsu 已提交
255 256
	    -e s/macppc/powerpc/\
	    -e s/sh.*/sh/)
W
wdenk 已提交
257

258
HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
W
wdenk 已提交
259 260
	    sed -e 's/\(cygwin\).*/cygwin/')

261
export	HOSTARCH HOSTOS
W
wdenk 已提交
262

263
#########################################################################
264

265
# set default to nothing for native builds
W
Wolfgang Denk 已提交
266
ifeq ($(HOSTARCH),$(ARCH))
267
CROSS_COMPILE ?=
268 269
endif

M
Masahiro Yamada 已提交
270 271 272
KCONFIG_CONFIG	?= .config
export KCONFIG_CONFIG

273 274 275 276 277
# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

278 279 280 281
HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)

282 283
HOSTCC       = cc
HOSTCXX      = c++
284
KBUILD_HOSTCFLAGS   := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
285
		$(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
286 287 288
KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
KBUILD_HOSTLDFLAGS  := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
KBUILD_HOSTLDLIBS   := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
289

290 291 292 293 294
# With the move to GCC 6, we have implicitly upgraded our language
# standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
# Some Linux distributions (including RHEL7, SLES13, Debian 8) still
# have older compilers as their default, so we make it explicit for
# these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
295
CSTD_FLAG := -std=gnu11
296
ifeq ($(HOSTOS),linux)
297
KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
298 299
endif

300
ifeq ($(HOSTOS),cygwin)
301
KBUILD_HOSTCFLAGS	+= -ansi
302 303 304 305 306 307 308 309
endif

# Mac OS X / Darwin's C preprocessor is Apple specific.  It
# generates numerous errors and warnings.  We want to bypass it
# and use GNU C's cpp.	To do this we pass the -traditional-cpp
# option to the compiler.  Note that the -traditional-cpp flag
# DOES NOT have the same semantics as GNU C's flag, all it does
# is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
310
#
311 312 313
# Apple's linker is similar, thanks to the new 2 stage linking
# multiple symbol definitions are treated as errors, hence the
# -multiply_defined suppress option to turn off this error.
314
#
315 316 317 318 319 320 321 322
ifeq ($(HOSTOS),darwin)
# get major and minor product version (e.g. '10' and '6' for Snow Leopard)
DARWIN_MAJOR_VERSION	= $(shell sw_vers -productVersion | cut -f 1 -d '.')
DARWIN_MINOR_VERSION	= $(shell sw_vers -productVersion | cut -f 2 -d '.')

os_x_before	= $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
	$(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)

認小默's avatar
認小默 已提交
323 324 325
os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
	$(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)	

326 327
# Snow Leopards build environment has no longer restrictions as described above
HOSTCC       = $(call os_x_before, 10, 5, "cc", "gcc")
328 329
KBUILD_HOSTCFLAGS  += $(call os_x_before, 10, 4, "-traditional-cpp")
KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
330 331 332 333

# since Lion (10.7) ASLR is on by default, but we use linker generated lists
# in some host tools which is a problem then ... so disable ASLR for these
# tools
334
KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 7, "", "-Xlinker -no_pie")
認小默's avatar
認小默 已提交
335 336 337

# macOS Mojave (10.14.X) 
# Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
338
KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
339 340
endif

341 342 343 344 345 346
# Decide whether to build built-in, modular, or both.
# Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

347 348 349 350
# If we have only "make modules", don't compile built-in objects.
# When we're building modules with modversions, we need to consider
# the built-in objects during the descend as well, in order to
# make sure the checksums are up to date before we record them.
351 352 353 354 355

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

356 357 358
# If we have "make <whatever> modules", compile modules
# in addition to whatever we do anyway.
# Just "make" or "make all" shall build modules as well
359 360 361 362 363 364 365 366 367 368

# U-Boot does not need modules
#ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
#  KBUILD_MODULES := 1
#endif

#ifeq ($(MAKECMDGOALS),)
#  KBUILD_MODULES := 1
#endif

369 370 371 372
# Check ths size of a binary:
# Args:
#   $1: File to check
#   #2: Size limit in bytes (decimal or 0xhex)
373 374 375 376 377
define size_check
	actual=$$( wc -c $1 | awk '{print $$1}'); \
	limit=$$( printf "%d" $2 ); \
	if test $$actual -gt $$limit; then \
		echo "$1 exceeds file size limit:" >&2; \
378
		echo "  limit:  $$(printf %#x $$limit) bytes" >&2; \
379 380
		echo "  actual: $$(printf %#x $$actual) bytes" >&2; \
		echo "  excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
381 382 383 384 385
		exit 1; \
	fi
endef
export size_check

386 387 388
export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

M
Masahiro Yamada 已提交
389
# We need some generic definitions (do not try to remake the file).
390 391
scripts/Kbuild.include: ;
include scripts/Kbuild.include
392

393
# Make variables (CC, etc...)
W
wdenk 已提交
394

395 396 397 398
AS		= $(CROSS_COMPILE)as
# Always use GNU ld
ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
LD		= $(CROSS_COMPILE)ld.bfd
399
else
400 401 402 403 404 405 406 407 408 409
LD		= $(CROSS_COMPILE)ld
endif
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
LDR		= $(CROSS_COMPILE)ldr
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
410 411
LEX		= flex
YACC		= bison
412
AWK		= awk
413
PERL		= perl
S
Stefano Babic 已提交
414
PYTHON		?= python
415 416
PYTHON2		= python2
PYTHON3		= python3
417
DTC		?= $(objtree)/scripts/dtc/dtc
418 419 420 421 422
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
		  -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)

423
KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
424 425 426

KBUILD_CFLAGS   := -Wall -Wstrict-prototypes \
		   -Wno-format-security \
427
		   -fno-builtin -ffreestanding $(CSTD_FLAG)
428
KBUILD_CFLAGS	+= -fshort-wchar -fno-strict-aliasing
429
KBUILD_AFLAGS   := -D__ASSEMBLY__
430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446
KBUILD_LDFLAGS  :=

ifeq ($(cc-name),clang)
ifneq ($(CROSS_COMPILE),)
CLANG_TARGET	:= --target=$(notdir $(CROSS_COMPILE:%-=%))
GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
CLANG_PREFIX	:= --prefix=$(GCC_TOOLCHAIN_DIR)
GCC_TOOLCHAIN	:= $(realpath $(GCC_TOOLCHAIN_DIR)/..)
endif
ifneq ($(GCC_TOOLCHAIN),)
CLANG_GCC_TC	:= --gcc-toolchain=$(GCC_TOOLCHAIN)
endif
KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
endif
447

448 449 450 451
# Don't generate position independent code
KBUILD_CFLAGS	+= $(call cc-option,-fno-PIE)
KBUILD_AFLAGS	+= $(call cc-option,-fno-PIE)

452 453 454
# Read UBOOTRELEASE from include/config/uboot.release (if it exists)
UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
455

456
export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
M
Masahiro Yamada 已提交
457
export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
458 459
export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
460
export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
461
export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
462

463
export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
464 465
export KBUILD_CFLAGS KBUILD_AFLAGS

466 467
export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)

468 469 470 471 472 473 474
# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# Files to ignore in find ... statements

475 476 477
export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o    \
			  -name CVS -o -name .pc -o -name .hg -o -name .git \) \
			  -prune -o
478 479 480 481 482 483 484 485 486 487 488 489 490 491 492
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
			 --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic
	$(Q)rm -f .tmp_quiet_recordmcount

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

493 494 495 496 497 498 499 500 501
PHONY += outputmakefile
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
outputmakefile:
ifneq ($(KBUILD_SRC),)
	$(Q)ln -fsn $(srctree) source
	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile \
	    $(srctree) $(objtree) $(VERSION) $(PATCHLEVEL)
502
endif
503

504 505 506 507 508 509 510 511
# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

512 513
version_h := include/generated/version_autogenerated.h
timestamp_h := include/generated/timestamp_autogenerated.h
514
defaultenv_h := include/generated/defaultenv_autogenerated.h
515
dt_h := include/generated/dt.h
516

517
no-dot-config-targets := clean clobber mrproper distclean \
518
			 help %docs check% coccicheck \
519
			 ubootversion backup tests check qcheck tcheck
520 521 522 523 524 525 526 527 528 529

config-targets := 0
mixed-targets  := 0
dot-config     := 1

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
	ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
		dot-config := 0
	endif
endif
W
Wolfgang Denk 已提交
530

531 532 533
ifeq ($(KBUILD_EXTMOD),)
        ifneq ($(filter config %config,$(MAKECMDGOALS)),)
                config-targets := 1
M
Masahiro Yamada 已提交
534
                ifneq ($(words $(MAKECMDGOALS)),1)
535 536 537
                        mixed-targets := 1
                endif
        endif
538
endif
W
wdenk 已提交
539

540 541 542 543
ifeq ($(mixed-targets),1)
# ===========================================================================
# We're called with mixed targets (*config and build targets).
# Handle them one by one.
544

545
PHONY += $(MAKECMDGOALS) __build_one_by_one
546

547
$(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
548 549
	@:

550
__build_one_by_one:
551 552 553 554
	$(Q)set -e; \
	for i in $(MAKECMDGOALS); do \
		$(MAKE) -f $(srctree)/Makefile $$i; \
	done
555

556 557 558 559 560
else
ifeq ($(config-targets),1)
# ===========================================================================
# *config targets only - make sure prerequisites are updated, and descend
# in scripts/kconfig to make the *config target
W
wdenk 已提交
561

M
Masahiro Yamada 已提交
562 563
KBUILD_DEFCONFIG := sandbox_defconfig
export KBUILD_DEFCONFIG KBUILD_KCONFIG
564

M
Masahiro Yamada 已提交
565
config: scripts_basic outputmakefile FORCE
566
	$(Q)$(MAKE) $(build)=scripts/kconfig $@
M
Masahiro Yamada 已提交
567 568

%config: scripts_basic outputmakefile FORCE
569
	$(Q)$(MAKE) $(build)=scripts/kconfig $@
570

571 572 573 574
else
# ===========================================================================
# Build targets only - this includes vmlinux, arch specific targets, clean
# targets and others. In general all targets except *config targets.
575

576 577 578 579 580 581 582
# Additional helpers built in scripts/
# Carefully list dependencies so we do not try to build scripts twice
# in parallel
PHONY += scripts
scripts: scripts_basic include/config/auto.conf
	$(Q)$(MAKE) $(build)=$(@)

583 584
ifeq ($(dot-config),1)
# Read in config
M
Masahiro Yamada 已提交
585 586 587 588 589 590 591 592 593 594 595 596 597 598
-include include/config/auto.conf

# Read in dependencies to all Kconfig* files, make sure to run
# oldconfig if changes are detected.
-include include/config/auto.conf.cmd

# To avoid any implicit rule to kick in, define an empty command
$(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;

# If .config is newer than include/config/auto.conf, someone tinkered
# with it and forgot to run make oldconfig.
# if auto.conf.cmd is missing then we are probably in a cleaned tree so
# we execute the config step to be sure to catch updated Kconfig files
include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
599
	$(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
600 601 602 603 604 605 606 607 608
	@# If the following part fails, include/config/auto.conf should be
	@# deleted so "make silentoldconfig" will be re-run on the next build.
	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
		{ rm -f include/config/auto.conf; false; }
	@# include/config.h has been updated after "make silentoldconfig".
	@# We need to touch include/config/auto.conf so it gets newer
	@# than include/config.h.
	@# Otherwise, 'make silentoldconfig' would be invoked twice.
	$(Q)touch include/config/auto.conf
M
Masahiro Yamada 已提交
609

610
u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
611 612
	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)

613 614
-include include/autoconf.mk
-include include/autoconf.mk.dep
W
wdenk 已提交
615

M
Masahiro Yamada 已提交
616 617 618 619
# We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
# is up-to-date. When we switch to a different board configuration, old CONFIG
# macros are still remaining in include/config/auto.conf. Without the following
# gimmick, wrong config.mk would be included leading nasty warnings/errors.
620 621 622 623 624
ifneq ($(wildcard $(KCONFIG_CONFIG)),)
ifneq ($(wildcard include/config/auto.conf),)
autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
						include/config/auto.conf)
ifeq ($(autoconf_is_old),)
625 626
include config.mk
include arch/$(ARCH)/Makefile
627
endif
628 629
endif
endif
630

631 632 633 634 635 636 637 638 639
# These are set by the arch-specific config.mk. Make sure they are exported
# so they can be used when building an EFI application.
export EFI_LDS		# Filename of EFI link script in arch/$(ARCH)/lib
export EFI_CRT0		# Filename of EFI CRT0 in arch/$(ARCH)/lib
export EFI_RELOC	# Filename of EFU relocation code in arch/$(ARCH)/lib
export CFLAGS_EFI	# Compiler flags to add when building EFI app
export CFLAGS_NON_EFI	# Compiler flags to remove when building EFI app
export EFI_TARGET	# binutils target if EFI is natively supported

640 641 642 643 644
# If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
# that (or fail if absent).  Otherwise, search for a linker script in a
# standard location.

ifndef LDSCRIPT
645
	#LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
646 647
	ifdef CONFIG_SYS_LDSCRIPT
		# need to strip off double quotes
648
		LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
649 650 651
	endif
endif

652
# If there is no specified link script, we look in a number of places for it
653 654
ifndef LDSCRIPT
	ifeq ($(wildcard $(LDSCRIPT)),)
655
		LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
656 657
	endif
	ifeq ($(wildcard $(LDSCRIPT)),)
658
		LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
659
	endif
660
	ifeq ($(wildcard $(LDSCRIPT)),)
661
		LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
662
	endif
663 664
endif

665
else
M
Masahiro Yamada 已提交
666 667
# Dummy target needed, because used as prerequisite
include/config/auto.conf: ;
668 669
endif # $(dot-config)

670 671 672 673 674 675 676 677
#
# Xtensa linker script cannot be preprocessed with -ansi because of
# preprocessor operations on strings that don't make C identifiers.
#
ifeq ($(CONFIG_XTENSA),)
LDPPFLAGS	+= -ansi
endif

678 679 680 681 682
ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
KBUILD_CFLAGS	+= -Os
else
KBUILD_CFLAGS	+= -O2
endif
683 684

KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
685
KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
686

687 688 689
# disable stringop warnings in gcc 8+
KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)

690 691 692
# Enabled with W=2, disabled by default as noisy
KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)

693 694 695
# change __FILE__ to the relative path from the srctree
KBUILD_CFLAGS	+= $(call cc-option,-fmacro-prefix-map=$(srctree)/=)

696 697 698 699 700 701
KBUILD_CFLAGS	+= -g
# $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
# option to the assembler.
KBUILD_AFLAGS	+= -g

# Report stack usage if supported
702 703 704
# ARC tools based on GCC 7.1 has an issue with stack usage
# with naked functions, see commit message for more details
ifndef CONFIG_ARC
705 706 707
ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
	KBUILD_CFLAGS += -fstack-usage
endif
708
endif
709 710

KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
711 712
KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)

713 714 715 716
ifeq ($(cc-name),clang)
KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
717 718 719 720 721 722 723
KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
# Quiet clang warning: comparison of unsigned expression < 0 is always false
KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
# CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
# source of a reference will be _MergedGlobals and not on of the whitelisted names.
# See modpost pattern 2
KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
724
KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
725 726 727 728 729
else

# These warnings generated too much noise in a regular build.
# Use make W=1 to enable them (see scripts/Makefile.extrawarn)
KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
730
endif
731

732 733 734
# Prohibit date/time macros, which would make the build non-deterministic
KBUILD_CFLAGS   += $(call cc-option,-Werror=date-time)

735
include scripts/Makefile.extrawarn
736

737 738 739 740 741
# Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
KBUILD_CPPFLAGS += $(KCPPFLAGS)
KBUILD_AFLAGS += $(KAFLAGS)
KBUILD_CFLAGS += $(KCFLAGS)

742 743
KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)

744 745
# Use UBOOTINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
746
UBOOTINCLUDE    := \
747 748 749 750 751 752 753 754 755
	-Iinclude \
	$(if $(KBUILD_SRC), -I$(srctree)/include) \
	$(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
		$(if $(CONFIG_HAS_THUMB2), \
			$(if $(CONFIG_CPU_V7M), \
				-I$(srctree)/arch/arm/thumb1/include), \
			-I$(srctree)/arch/arm/thumb1/include)) \
	-I$(srctree)/arch/$(ARCH)/include \
	-include $(srctree)/include/linux/kconfig.h
756 757 758 759

NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)

# FIX ME
M
Masahiro Yamada 已提交
760 761
cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
							$(NOSTDINC_FLAGS)
762 763
c_flags := $(KBUILD_CFLAGS) $(cpp_flags)

W
wdenk 已提交
764 765 766
#########################################################################
# U-Boot objects....order is important (i.e. start must be first)

767
HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
768

769 770 771 772 773 774 775 776 777 778 779 780 781
libs-y += lib/
libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
libs-$(CONFIG_OF_EMBED) += dts/
libs-y += fs/
libs-y += net/
libs-y += disk/
libs-y += drivers/
libs-y += drivers/dma/
libs-y += drivers/gpio/
libs-y += drivers/i2c/
libs-y += drivers/net/
libs-y += drivers/net/phy/
libs-y += drivers/power/ \
782
	drivers/power/domain/ \
783 784 785
	drivers/power/fuel_gauge/ \
	drivers/power/mfd/ \
	drivers/power/pmic/ \
786 787
	drivers/power/battery/ \
	drivers/power/regulator/
788 789 790
libs-y += drivers/spi/
libs-$(CONFIG_FMAN_ENET) += drivers/net/fm/
libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
791
libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
792
libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
793
libs-y += drivers/serial/
794
libs-y += drivers/usb/cdns3/
795
libs-y += drivers/usb/dwc3/
796
libs-y += drivers/usb/common/
797
libs-y += drivers/usb/emul/
798
libs-y += drivers/usb/eth/
799
libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
800 801
libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
802
libs-y += drivers/usb/host/
C
Chunfeng Yun 已提交
803
libs-y += drivers/usb/mtu3/
804 805 806 807
libs-y += drivers/usb/musb/
libs-y += drivers/usb/musb-new/
libs-y += drivers/usb/phy/
libs-y += drivers/usb/ulpi/
808
libs-y += cmd/
809
libs-y += common/
810
libs-y += env/
811
libs-$(CONFIG_API) += api/
S
Simon Glass 已提交
812 813 814
ifdef CONFIG_POST
libs-y += post/
endif
815
libs-$(CONFIG_UNIT_TEST) += test/
816
libs-$(CONFIG_UT_ENV) += test/env/
H
Heiko Stuebner 已提交
817
libs-$(CONFIG_UT_OPTEE) += test/optee/
818
libs-$(CONFIG_UT_OVERLAY) += test/overlay/
819

820
libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
821 822

libs-y := $(sort $(libs-y))
823

824 825 826 827 828 829 830 831
u-boot-dirs	:= $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples

u-boot-alldirs	:= $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))

libs-y		:= $(patsubst %/, %/built-in.o, $(libs-y))

u-boot-init := $(head-y)
u-boot-main := $(libs-y)
832

W
wdenk 已提交
833

W
wdenk 已提交
834
# Add GCC lib
835
ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
836
PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
837
else
838
PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
839 840
endif
PLATFORM_LIBS += $(PLATFORM_LIBGCC)
841 842 843 844 845 846

ifdef CONFIG_CC_COVERAGE
KBUILD_CFLAGS += --coverage
PLATFORM_LIBGCC += -lgcov
endif

847
export PLATFORM_LIBS
848
export PLATFORM_LIBGCC
W
wdenk 已提交
849

850 851 852 853
# Special flags for CPP when processing the linker script.
# Pass the version down so we can handle backwards compatibility
# on the fly.
LDPPFLAGS += \
854
	-include $(srctree)/include/u-boot/u-boot.lds.h \
855
	-DCPUDIR=$(CPUDIR) \
856 857 858
	$(shell $(LD) --version | \
	  sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')

859
#########################################################################
W
wdenk 已提交
860 861
#########################################################################

862
ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
863
BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
864 865 866 867
else
BOARD_SIZE_CHECK =
endif

868
ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
869
SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
870 871 872 873
else
SPL_SIZE_CHECK =
endif

874
ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
S
Simon Glass 已提交
875 876 877 878 879
TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
else
TPL_SIZE_CHECK =
endif

880
# Statically apply RELA-style relocations (currently arm64 only)
881 882 883
# This is useful for arm64 where static relocation needs to be performed on
# the raw binary, but certain simulators only accept an ELF file (but don't
# do the relocation).
884 885
ifneq ($(CONFIG_STATIC_RELA),)
# $(1) is u-boot ELF, $(2) is u-boot bin, $(3) is text base
886 887 888 889 890
quiet_cmd_static_rela = RELOC   $@
cmd_static_rela = \
	start=$$($(NM) $(2) | grep __rel_dyn_start | cut -f 1 -d ' '); \
	end=$$($(NM) $(2) | grep __rel_dyn_end | cut -f 1 -d ' '); \
	tools/relocate-rela $(3) $(4) $$start $$end
891
else
892
quiet_cmd_static_rela =
893
cmd_static_rela =
894 895
endif

S
Simon Glass 已提交
896 897
# Always append INPUTS so that arch config.mk's can add custom ones
INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
898

S
Simon Glass 已提交
899
INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
900
ifeq ($(CONFIG_SPL_FSL_PBL),y)
S
Simon Glass 已提交
901
INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
902
else
T
Tom Rini 已提交
903
ifneq ($(CONFIG_NXP_ESBC), y)
904 905
# For Secure Boot The Image needs to be signed and Header must also
# be included. So The image has to be built explicitly
S
Simon Glass 已提交
906
INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
907
endif
908
endif
S
Simon Glass 已提交
909
INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
910
ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
S
Simon Glass 已提交
911
INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
912
else
913
ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
S
Simon Glass 已提交
914
INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
915
else
S
Simon Glass 已提交
916
INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
917
endif
918
endif
S
Simon Glass 已提交
919 920
INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
INPUTS-$(CONFIG_OF_SEPARATE) += u-boot.dtb
921
ifeq ($(CONFIG_SPL_FRAMEWORK),y)
S
Simon Glass 已提交
922
INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
923
endif
S
Simon Glass 已提交
924
INPUTS-$(CONFIG_OF_HOSTFILE) += u-boot.dtb
925
ifneq ($(CONFIG_SPL_TARGET),)
S
Simon Glass 已提交
926
INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
927
endif
S
Simon Glass 已提交
928 929 930
INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
931

932 933
# Generate this input file for binman
ifeq ($(CONFIG_SPL),)
S
Simon Glass 已提交
934
INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
935
endif
936

937 938
# Add optional build target if defined in board/cpu/soc headers
ifneq ($(CONFIG_BUILD_TARGET),)
S
Simon Glass 已提交
939
INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
940 941
endif

942
ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
S
Simon Glass 已提交
943
INPUTS-y += init_sp_bss_offset_check
944 945
endif

946
ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
S
Simon Glass 已提交
947
INPUTS-y += u-boot-with-dtb.bin
948 949
endif

950 951 952 953 954
ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
# On ARM64 this target is produced by binman so we don't need this dep
ifeq ($(CONFIG_ARM64),y)
ifeq ($(CONFIG_SPL),y)
# TODO: Get binman to generate this too
S
Simon Glass 已提交
955
INPUTS-y += u-boot-rockchip.bin
956
endif
957 958 959 960 961 962 963
else
ifeq ($(CONFIG_SPL),y)
# Generate these inputs for binman which will create the output files
INPUTS-y += idbloader.img u-boot.img
endif
endif
endif
964

965 966 967 968
INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
	$(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
	$(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)

969
LDFLAGS_u-boot += $(LDFLAGS_FINAL)
970 971 972 973

# Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)

974
ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
975 976
LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
endif
977

978 979 980 981 982 983
# insure the checker run with the right endianness
CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)

# the checker needs the correct machine size
CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)

984
# Normally we fill empty space with 0xff
985
quiet_cmd_objcopy = OBJCOPY $@
986 987 988 989 990 991
cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
	$(OBJCOPYFLAGS_$(@F)) $< $@

# Provide a version which does not do this, for use by EFI
quiet_cmd_zobjcopy = OBJCOPY $@
cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
992

993 994 995
quiet_cmd_efipayload = OBJCOPY $@
cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@

996 997
MKIMAGEOUTPUT ?= /dev/null

M
Marek Vasut 已提交
998
quiet_cmd_mkimage = MKIMAGE $@
999
cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
1000
	>$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1001

1002
quiet_cmd_mkfitimage = MKIMAGE $@
1003 1004
cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
	-f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
1005
	>$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1006

1007 1008 1009
quiet_cmd_cat = CAT     $@
cmd_cat = cat $(filter-out $(PHONY), $^) > $@

1010 1011 1012
append = cat $(filter-out $< $(PHONY), $^) >> $@

quiet_cmd_pad_cat = CAT     $@
1013
cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1014

1015 1016 1017
quiet_cmd_lzma = LZMA    $@
cmd_lzma = lzma -c -z -k -9 $< > $@

1018 1019
cfg: u-boot.cfg

1020 1021 1022 1023
quiet_cmd_cfgcheck = CFGCHK  $2
cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
		$(srctree)/scripts/config_whitelist.txt $(srctree)

S
Simon Glass 已提交
1024 1025 1026
PHONY += inputs
inputs: $(INPUTS-y)

1027 1028 1029 1030 1031 1032 1033 1034
all: .binman_stamp inputs
ifeq ($(CONFIG_BINMAN),y)
	$(call if_changed,binman)
endif

# Timestamp file to make sure that binman always runs
.binman_stamp: FORCE
	@touch $@
S
Simon Glass 已提交
1035

1036 1037
ifeq ($(CONFIG_DEPRECATED),y)
	$(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
1038 1039 1040 1041 1042
ifeq ($(CONFIG_SPI),y)
ifneq ($(CONFIG_DM_SPI)$(CONFIG_OF_CONTROL),yy)
	$(warning "The relevant config item with associated code will remove in v2019.07 release.")
endif
endif
1043
endif
1044 1045 1046 1047 1048 1049 1050 1051
ifneq ($(CONFIG_DM),y)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
	@echo >&2 "compulsory starting with the v2020.01 release."
	@echo >&2 "Failure to update may result in board removal."
	@echo >&2 "See doc/driver-model/migration.rst for more info."
	@echo >&2 "===================================================="
endif
1052
ifeq ($(CONFIG_MMC),y)
1053
ifneq ($(CONFIG_DM_MMC)$(CONFIG_BLK),yy)
1054 1055 1056 1057
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does not use CONFIG_DM_MMC. Please update"
	@echo >&2 "the board to use CONFIG_DM_MMC before the v2019.04 release."
	@echo >&2 "Failure to update by the deadline may result in board removal."
1058
	@echo >&2 "See doc/driver-model/migration.rst for more info."
1059
	@echo >&2 "===================================================="
1060 1061 1062 1063
endif
endif
ifeq ($(CONFIG_USB),y)
ifneq ($(CONFIG_DM_USB)$(CONFIG_OF_CONTROL)$(CONFIG_BLK),yyy)
1064 1065 1066 1067
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does not use CONFIG_DM_USB. Please update"
	@echo >&2 "the board to use CONFIG_DM_USB before the v2019.07 release."
	@echo >&2 "Failure to update by the deadline may result in board removal."
1068
	@echo >&2 "See doc/driver-model/migration.rst for more info."
1069
	@echo >&2 "===================================================="
1070
endif
1071
endif
1072
ifeq ($(CONFIG_MVSATA_IDE),y)
1073
	@echo >&2 "===================== WARNING ======================"
1074 1075 1076 1077 1078
	@echo >&2 "This board does use CONFIG_MVSATA_IDE which is not"
	@echo >&2 "ported to driver-model (DM) yet. Please update the storage"
	@echo >&2 "controller driver to use CONFIG_AHCI before the v2019.07"
	@echo >&2 "release."
	@echo >&2 "Failure to update by the deadline may result in board removal."
1079
	@echo >&2 "See doc/driver-model/migration.rst for more info."
1080 1081 1082 1083 1084 1085 1086 1087
	@echo >&2 "===================================================="
endif
ifeq ($(CONFIG_LIBATA),y)
ifneq ($(CONFIG_AHCI),y)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does use CONFIG_LIBATA but has CONFIG_AHCI not"
	@echo >&2 "enabled. Please update the storage controller driver to use"
	@echo >&2 "CONFIG_AHCI before the v2019.07 release."
1088
	@echo >&2 "Failure to update by the deadline may result in board removal."
1089
	@echo >&2 "See doc/driver-model/migration.rst for more info."
1090
	@echo >&2 "===================================================="
1091
endif
1092
endif
1093 1094 1095 1096 1097 1098
ifeq ($(CONFIG_PCI),y)
ifneq ($(CONFIG_DM_PCI),y)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does not use CONFIG_DM_PCI Please update"
	@echo >&2 "the board to use CONFIG_DM_PCI before the v2019.07 release."
	@echo >&2 "Failure to update by the deadline may result in board removal."
1099
	@echo >&2 "See doc/driver-model/migration.rst for more info."
1100 1101 1102
	@echo >&2 "===================================================="
endif
endif
1103 1104 1105 1106 1107 1108
ifneq ($(CONFIG_LCD)$(CONFIG_VIDEO),)
ifneq ($(CONFIG_DM_VIDEO),y)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does not use CONFIG_DM_VIDEO Please update"
	@echo >&2 "the board to use CONFIG_DM_VIDEO before the v2019.07 release."
	@echo >&2 "Failure to update by the deadline may result in board removal."
1109
	@echo >&2 "See doc/driver-model/migration.rst for more info."
1110 1111 1112
	@echo >&2 "===================================================="
endif
endif
1113
ifeq ($(CONFIG_OF_EMBED),y)
1114 1115 1116 1117 1118 1119
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
	@echo >&2 "be used for debugging purposes. Please use"
	@echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
	@echo >&2 "See doc/README.fdt-control for more info."
	@echo >&2 "===================================================="
1120
endif
1121 1122 1123 1124 1125 1126
ifeq ($(CONFIG_SPI_FLASH),y)
ifneq ($(CONFIG_DM_SPI_FLASH)$(CONFIG_OF_CONTROL),yy)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does not use CONFIG_DM_SPI_FLASH. Please update"
	@echo >&2 "the board to use CONFIG_SPI_FLASH before the v2019.07 release."
	@echo >&2 "Failure to update by the deadline may result in board removal."
1127
	@echo >&2 "See doc/driver-model/migration.rst for more info."
1128
	@echo >&2 "===================================================="
1129
endif
1130 1131 1132 1133 1134 1135 1136 1137
endif
ifneq ($(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG),)
ifneq ($(CONFIG_WDT),y)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does not use CONFIG_WDT (DM watchdog support)."
	@echo >&2 "Please update the board to use CONFIG_WDT before the"
	@echo >&2 "v2019.10 release."
	@echo >&2 "Failure to update by the deadline may result in board removal."
1138
	@echo >&2 "See doc/driver-model/migration.rst for more info."
1139 1140
	@echo >&2 "===================================================="
endif
1141 1142 1143 1144 1145 1146 1147 1148 1149 1150 1151
endif
ifneq ($(CONFIG_NET),)
ifneq ($(CONFIG_DM_ETH),y)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board does not use CONFIG_DM_ETH (Driver Model"
	@echo >&2 "for Ethernet drivers). Please update the board to use"
	@echo >&2 "CONFIG_DM_ETH before the v2020.07 release. Failure to"
	@echo >&2 "update by the deadline may result in board removal."
	@echo >&2 "See doc/driver-model/migration.rst for more info."
	@echo >&2 "===================================================="
endif
1152 1153 1154 1155 1156 1157 1158
endif
ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
	@echo >&2 "===================== WARNING ======================"
	@echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
	@echo >&2 "to binman instead, to avoid the proliferation of"
	@echo >&2 "arch-specific scripts with no tests."
	@echo >&2 "===================================================="
S
Simon Glass 已提交
1159
endif
1160 1161 1162
	@# Check that this build does not use CONFIG options that we do not
	@# know about unless they are in Kconfig. All the existing CONFIG
	@# options are whitelisted, so new ones should not be added.
1163
	$(call cmd,cfgcheck,u-boot.cfg)
W
wdenk 已提交
1164

1165
PHONY += dtbs
1166 1167
dtbs: dts/dt.dtb
	@:
1168
dts/dt.dtb: u-boot
1169
	$(Q)$(MAKE) $(build)=dts dtbs
1170

1171 1172 1173
quiet_cmd_copy = COPY    $@
      cmd_copy = cp $< $@

1174
ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1175

1176 1177 1178 1179 1180 1181 1182 1183 1184 1185 1186 1187 1188 1189
ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
FINAL_DTB_CONTAINER = fit-dtb.blob.gz
else
FINAL_DTB_CONTAINER = fit-dtb.blob
endif

fit-dtb.blob.gz: fit-dtb.blob
	@gzip -kf9 $< > $@

fit-dtb.blob.lzo: fit-dtb.blob
	@lzop -f9 $< > $@

1190 1191
fit-dtb.blob: dts/dt.dtb FORCE
	$(call if_changed,mkimage)
1192 1193 1194 1195
ifneq ($(SOURCE_DATE_EPOCH),)
	touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
	chmod 0600 fit-dtb.blob
endif
1196 1197 1198 1199 1200

MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
	-a 0 -e 0 -E \
	$(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null

1201 1202 1203 1204
ifneq ($(EXT_DTB),)
u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
		$(call if_changed,cat)
else
1205
u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1206
	$(call if_changed,cat)
1207
endif
1208 1209 1210

u-boot.bin: u-boot-fit-dtb.bin FORCE
	$(call if_changed,copy)
1211 1212 1213 1214

u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
	$(call if_changed,cat)

1215
else ifeq ($(CONFIG_OF_SEPARATE),y)
1216
u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1217
	$(call if_changed,cat)
1218

1219 1220 1221 1222 1223 1224 1225
u-boot.bin: u-boot-dtb.bin FORCE
	$(call if_changed,copy)
else
u-boot.bin: u-boot-nodtb.bin FORCE
	$(call if_changed,copy)
endif

1226 1227 1228 1229 1230 1231 1232 1233 1234
# we call Makefile in arch/arm/mach-imx which
# has targets which are dependent on targets defined
# here. make could not resolve them and we must ensure
# that they are finished before calling imx targets
ifeq ($(CONFIG_MULTI_DTB_FIT),y)
IMX_DEPS = u-boot-fit-dtb.bin
endif

%.imx: $(IMX_DEPS) %.bin
1235
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1236
	$(BOARD_SIZE_CHECK)
1237

1238 1239 1240 1241 1242 1243
%.vyb: %.imx
	$(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@

quiet_cmd_copy = COPY    $@
      cmd_copy = cp $< $@

1244 1245 1246
u-boot.dtb: dts/dt.dtb
	$(call cmd,copy)

1247
OBJCOPYFLAGS_u-boot.hex := -O ihex
W
wdenk 已提交
1248

1249
OBJCOPYFLAGS_u-boot.srec := -O srec
W
wdenk 已提交
1250

1251 1252 1253
u-boot.hex u-boot.srec: u-boot FORCE
	$(call if_changed,objcopy)

1254 1255 1256 1257 1258
OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)

u-boot-elf.srec: u-boot.elf FORCE
	$(call if_changed,objcopy)

1259 1260 1261 1262 1263
OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)

spl/u-boot-spl.srec: spl/u-boot-spl FORCE
	$(call if_changed,objcopy)

1264 1265 1266
%.scif: %.srec
	$(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@

1267
OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1268 1269
		$(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
		$(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),-R .bootpg -R .resetvec)
1270

1271 1272
binary_size_check: u-boot-nodtb.bin FORCE
	@file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1273
	map_size=$(shell cat u-boot.map | \
1274
		awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1275
		| sed 's/0X//g' \
1276
		| bc); \
1277 1278
	if [ "" != "$$map_size" ]; then \
		if test $$map_size -ne $$file_size; then \
1279
			echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1280
			echo "  but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1281 1282 1283 1284
			exit 1; \
		fi \
	fi

1285
ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1286 1287 1288 1289 1290 1291 1292 1293 1294 1295 1296 1297 1298 1299 1300 1301 1302 1303 1304 1305 1306 1307 1308 1309 1310 1311
ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
else
subtract_sys_malloc_f_len = true
endif
# The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
# so low that the DTB could probably use 90%+ of the available space, for
# current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
# safe for now and tweak this later if space becomes tight.
# A rejected alternative would be to check that some absolute minimum stack
# space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
# deliberately build-specific, to take account of build-to-build stack usage
# differences due to different feature sets, there is no common absolute value
# to check against.
init_sp_bss_offset_check: u-boot.dtb FORCE
	@dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
	space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
	$(subtract_sys_malloc_f_len) ; \
	quarter_space=$$(($${space} / 4)) ; \
	if [ $${dtb_size} -gt $${quarter_space} ]; then \
		echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
		echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
		exit 1 ; \
	fi
endif

P
Pali Rohár 已提交
1312
shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1313 1314

quiet_cmd_objcopy_uboot = OBJCOPY $@
1315
ifdef cmd_static_rela
1316
cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1317 1318 1319
else
cmd_objcopy_uboot = $(cmd_objcopy)
endif
1320

1321
u-boot-nodtb.bin: u-boot FORCE
1322
	$(call if_changed,objcopy_uboot)
1323
	$(BOARD_SIZE_CHECK)
W
wdenk 已提交
1324

1325
u-boot.ldr:	u-boot
1326
		$(CREATE_LDR_ENV)
1327
		$(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1328
		$(BOARD_SIZE_CHECK)
1329

S
Simon Glass 已提交
1330 1331
# binman
# ---------------------------------------------------------------------------
1332
# Use 'make BINMAN_DEBUG=1' to enable debugging
1333
# Use 'make BINMAN_VERBOSE=3' to set vebosity level
1334
default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
S
Simon Glass 已提交
1335
quiet_cmd_binman = BINMAN  $@
1336
cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1337
                --toolpath $(objtree)/tools \
1338
		$(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1339
		build -u -d u-boot.dtb -O . -m --allow-missing \
1340
		-I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1341 1342
		-I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
		-a atf-bl31-path=${BL31} \
1343
		-a default-dt=$(default_dt) \
1344
		-a scp-path=$(SCP) \
1345
		$(BINMAN_$(@F))
S
Simon Glass 已提交
1346

1347 1348 1349
OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex

OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1350

1351 1352
u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
	$(call if_changed,objcopy)
1353

1354 1355 1356 1357 1358
#
# U-Boot entry point, needed for booting of full-blown U-Boot
# from the SPL U-Boot version.
#
ifndef CONFIG_SYS_UBOOT_START
1359
CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1360 1361
endif

1362
# Boards with more complex image requirements can provide an .its source file
1363
# or a generator script
1364 1365
# NOTE: Please do not use this. We are migrating away from Makefile rules to use
# binman instead.
1366
ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1367 1368 1369
U_BOOT_ITS := u-boot.its
$(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
	$(call if_changed,copy)
1370
else
1371
ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1372
U_BOOT_ITS := u-boot.its
1373 1374 1375
ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-imx/mkimage_fit_atf.sh")
U_BOOT_ITS_DEPS += u-boot-nodtb.bin
endif
1376 1377 1378 1379
ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
U_BOOT_ITS_DEPS += u-boot
endif
$(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1380 1381 1382 1383 1384
	$(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
	$(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
endif
endif

1385 1386 1387
ifdef CONFIG_SPL_LOAD_FIT
MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1388
	-p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1389
	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1390
	$(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1391 1392
	$(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
	$(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1393
else
1394 1395 1396
MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1397 1398 1399
MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1400
u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1401
endif
1402

1403 1404
MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)

1405 1406 1407 1408 1409 1410 1411 1412 1413 1414 1415 1416
# Some boards have the kwbimage.cfg file written in advance, while some
# other boards generate it on the fly during the build in the build tree.
# Let's check if the file exists in the build tree first, otherwise we
# fall back to use the one in the source tree.
KWD_CONFIG_FILE = $(shell \
	if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
		echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
	else \
		echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
	fi)

MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1417
	-T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1418

1419
MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
M
Mario Six 已提交
1420 1421
	-T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
	$(if $(KEYDIR),-k $(KEYDIR))
1422

1423 1424
MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
		-R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage
1425

1426 1427 1428 1429 1430 1431
ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
UBOOT_BIN := u-boot-with-dtb.bin
else
UBOOT_BIN := u-boot.bin
endif

1432 1433 1434 1435 1436 1437 1438 1439 1440 1441
MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
	-n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"

u-boot.bin.lzma: u-boot.bin FORCE
	$(call if_changed,lzma)

u-boot-lzma.img: u-boot.bin.lzma FORCE
	$(call if_changed,mkimage)

1442
u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1443 1444
		$(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
			$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_OF_HOSTFILE),dts/dt.dtb) \
1445
		,$(UBOOT_BIN)) FORCE
1446
	$(call if_changed,mkimage)
1447
	$(BOARD_SIZE_CHECK)
1448

1449 1450 1451 1452 1453 1454
ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
MKIMAGEFLAGS_u-boot.itb =
else
MKIMAGEFLAGS_u-boot.itb = -E
endif

1455
ifdef U_BOOT_ITS
1456 1457 1458
u-boot.itb: u-boot-nodtb.bin \
		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_OF_HOSTFILE),dts/dt.dtb) \
		$(U_BOOT_ITS) FORCE
1459
	$(call if_changed,mkfitimage)
1460
	$(BOARD_SIZE_CHECK)
1461
endif
1462

1463
u-boot-spl.kwb: u-boot.img spl/u-boot-spl.bin FORCE
1464 1465
	$(call if_changed,mkimage)

1466 1467
u-boot.sha1:	u-boot.bin
		tools/ubsha1 u-boot.bin
1468

1469
u-boot.dis:	u-boot
W
wdenk 已提交
1470 1471
		$(OBJDUMP) -d $< > $@

Y
York Sun 已提交
1472 1473
ifneq ($(CONFIG_SPL_PAYLOAD),)
SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1474
else
1475
SPL_PAYLOAD := u-boot.bin
1476
endif
1477

1478 1479
SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)

1480 1481
OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
				   --pad-to=$(CONFIG_SPL_PAD_TO)
1482
u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1483
	$(call if_changed,pad_cat)
1484

1485
ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
J
Jagan Teki 已提交
1486

1487 1488
# TPL + SPL
ifeq ($(CONFIG_SPL)$(CONFIG_TPL),yy)
1489
MKIMAGEFLAGS_u-boot-tpl-rockchip.bin = -n $(CONFIG_SYS_SOC) -T rksd
1490
tpl/u-boot-tpl-rockchip.bin: tpl/u-boot-tpl.bin FORCE
1491
	$(call if_changed,mkimage)
1492
idbloader.img: tpl/u-boot-tpl-rockchip.bin spl/u-boot-spl.bin FORCE
1493
	$(call if_changed,cat)
1494
else
1495
MKIMAGEFLAGS_idbloader.img = -n $(CONFIG_SYS_SOC) -T rksd
1496 1497
idbloader.img: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)
1498 1499
endif

1500
ifeq ($(CONFIG_ARM64),y)
1501 1502 1503 1504 1505 1506 1507
OBJCOPYFLAGS_u-boot-rockchip.bin = -I binary -O binary \
	--pad-to=$(CONFIG_SPL_PAD_TO) --gap-fill=0xff
u-boot-rockchip.bin: idbloader.img u-boot.itb FORCE
	$(call if_changed,pad_cat)
endif # CONFIG_ARM64

endif # CONFIG_ARCH_ROCKCHIP
1508

1509
ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1510 1511 1512 1513 1514 1515 1516
MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)

lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)

OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)

1517
lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1518 1519 1520 1521
	$(call if_changed,objcopy)

OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)

1522
lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1523 1524
	$(call if_changed,objcopy)

1525
lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1526 1527
	$(call if_changed,cat)

1528
endif
1529

1530 1531 1532 1533
OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
				   --pad-to=$(CONFIG_TPL_PAD_TO)
tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
	$(call if_changed,pad_cat)
1534

1535
SPL: spl/u-boot-spl.bin FORCE
1536
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1537

P
Peng Fan 已提交
1538
ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
P
Peng Fan 已提交
1539 1540 1541 1542 1543 1544 1545
ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
u-boot.cnt: u-boot.bin FORCE
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@

flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
else
P
Peng Fan 已提交
1546 1547 1548
flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
endif
P
Peng Fan 已提交
1549
endif
P
Peng Fan 已提交
1550

1551 1552 1553 1554
u-boot.uim: u-boot.bin FORCE
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@

u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1555
	$(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1556

1557 1558 1559 1560
MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)

u-boot.ubl: u-boot-with-spl.bin FORCE
	$(call if_changed,mkimage)
1561

1562 1563 1564 1565 1566
MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
	$(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
	-T aisimage -e $(CONFIG_SPL_TEXT_BASE)
spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)
1567

1568
OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1569 1570
u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
	$(call if_changed,pad_cat)
1571

1572 1573
u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
	$(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1574
u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1575
	$(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1576

1577 1578 1579 1580 1581 1582
# On x600 (SPEAr600) U-Boot is appended to U-Boot SPL.
# Both images are created using mkimage (crc etc), so that the ROM
# bootloader can check its integrity. Padding needs to be done to the
# SPL image (with mkimage header) and not the binary. Otherwise the resulting image
# which is loaded/copied by the ROM bootloader to SRAM doesn't fit.
# The resulting image containing both U-Boot images is called u-boot.spr
1583 1584 1585 1586 1587 1588 1589 1590 1591
MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
	-a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)

OBJCOPYFLAGS_u-boot.spr = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
			  --gap-fill=0xff
u-boot.spr: spl/u-boot-spl.img u-boot.img FORCE
	$(call if_changed,pad_cat)
1592

1593
ifneq ($(CONFIG_ARCH_SOCFPGA),)
1594
quiet_cmd_gensplx4 = GENSPLX4 $@
1595 1596 1597 1598
cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0		\
			--pad-to=$(CONFIG_SPL_PAD_TO)			\
			spl/u-boot-spl.sfp spl/u-boot-spl.sfp &&        \
		cat	spl/u-boot-spl.sfp spl/u-boot-spl.sfp		\
1599
			spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1600 1601 1602
spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
	$(call if_changed,gensplx4)

1603
quiet_cmd_socboot = SOCBOOT $@
1604
cmd_socboot = cat	spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1605
u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1606
	$(call if_changed,socboot)
1607

1608 1609
quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
cmd_gensplpadx4 =  dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1610 1611 1612
		   cat	spl/u-boot-spl.sfp spl/u-boot-spl.pad \
			spl/u-boot-spl.sfp spl/u-boot-spl.pad \
			spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1613
			spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1614
			{ rm -f $@ spl/u-boot-spl.pad; false; }
1615 1616 1617 1618
u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
	$(call if_changed,gensplpadx4)

quiet_cmd_socnandboot = SOCNANDBOOT $@
1619
cmd_socnandboot = cat	u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1620
u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1621 1622
	$(call if_changed,socnandboot)

1623 1624
endif

1625 1626 1627 1628 1629 1630 1631 1632 1633 1634 1635 1636
ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
	$(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
	$(call if_changed,binman)

ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
u-boot-br.bin: u-boot FORCE
	$(call if_changed,objcopy)
endif
endif

1637 1638 1639 1640
quiet_cmd_ldr = LD      $@
cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
	       $(filter-out FORCE,$^) -o $@

1641
ifdef CONFIG_X86
1642 1643 1644 1645 1646 1647
OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
u-boot-x86-start16.bin: u-boot FORCE
	$(call if_changed,objcopy)

OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
u-boot-x86-reset16.bin: u-boot FORCE
1648
	$(call if_changed,objcopy)
1649

1650
endif # CONFIG_X86
1651

1652 1653 1654 1655
OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
u-boot-app.efi: u-boot FORCE
	$(call if_changed,zobjcopy)

1656
u-boot.bin.o: u-boot.bin FORCE
1657 1658 1659 1660 1661 1662 1663 1664
	$(call if_changed,efipayload)

u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
	$(call if_changed_dep,cpp_lds)

# Rule to link the EFI payload which contains a stub and a U-Boot binary
quiet_cmd_u-boot_payload ?= LD      $@
      cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
S
Simon Glass 已提交
1665
      -T u-boot-payload.lds arch/x86/cpu/call32.o \
1666
      lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1667
      $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1668

1669
u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1670 1671 1672 1673 1674 1675
	$(call if_changed,u-boot_payload)

OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
u-boot-payload.efi: u-boot-payload FORCE
	$(call if_changed,zobjcopy)

1676 1677
u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
	$(call if_changed,cat)
1678

1679 1680 1681 1682
#Add a target to create boot binary having SPL binary in PBI format
#concatenated with u-boot binary. It is need by PowerPC SoC having
#internal SRAM <= 512KB.
MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1683 1684
		-R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
		-A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1685 1686 1687 1688

spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
	$(call if_changed,mkimage)

1689 1690 1691
ifeq ($(ARCH),arm)
UBOOT_BINLOAD := u-boot.img
else
1692 1693 1694
ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
UBOOT_BINLOAD := u-boot-with-dtb.bin
else
1695 1696
UBOOT_BINLOAD := u-boot.bin
endif
1697
endif
1698

1699 1700 1701
OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
			  --gap-fill=0xff

1702
u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1703 1704
	$(call if_changed,pad_cat)

1705 1706 1707 1708 1709
# PPC4xx needs the SPL at the end of the image, since the reset vector
# is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
# and need to introduce a new build target with the full blown U-Boot
# at the start padded up to the start of the SPL image. And then concat
# the SPL image to the end.
1710 1711 1712 1713 1714

OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
	--pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
	$(call if_changed,pad_cat)
1715

1716 1717
quiet_cmd_u-boot-elf ?= LD      $@
	cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1718
	-T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1719
	-Ttext=$(CONFIG_SYS_TEXT_BASE)
1720
u-boot.elf: u-boot.bin u-boot-elf.lds
1721 1722
	$(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
	$(call if_changed,u-boot-elf)
1723

1724 1725 1726
u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
	$(call if_changed_dep,cpp_lds)

1727 1728 1729 1730 1731 1732 1733 1734
# MediaTek's ARM-based u-boot needs a header to contains its load address
# which is parsed by the BootROM.
# If the SPL build is enabled, the header will be added to the spl binary,
# and the spl binary and the u-boot.img will be combined into one file.
# Otherwise the header will be added to the u-boot.bin directly.

ifeq ($(CONFIG_SPL),y)
spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1735 1736 1737

u-boot-mtk.bin: u-boot-with-spl.bin
	$(call if_changed,copy)
1738 1739 1740 1741 1742 1743 1744 1745 1746
else
MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
	-a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
	-n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"

u-boot-mtk.bin: u-boot.bin FORCE
	$(call if_changed,mkimage)
endif

1747 1748 1749 1750 1751 1752
quiet_cmd_endian_swap = SWAP    $@
      cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@

u-boot-swap.bin: u-boot.bin FORCE
	$(call if_changed,endian_swap)

1753 1754
ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)

1755 1756 1757
# Rule to link u-boot
# May be overridden by arch/$(ARCH)/config.mk
quiet_cmd_u-boot__ ?= LD      $@
1758
      cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
1759 1760
      -T u-boot.lds $(u-boot-init)                             \
      --start-group $(u-boot-main) --end-group                 \
1761 1762
      $(PLATFORM_LIBS) -Map u-boot.map;                        \
      $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1763

1764 1765
quiet_cmd_smap = GEN     common/system_map.o
cmd_smap = \
1766 1767 1768 1769
	smap=`$(call SYSTEM_MAP,u-boot) | \
		awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
	$(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
		-c $(srctree)/common/system_map.c -o common/system_map.o
1770

1771
u-boot:	$(u-boot-init) $(u-boot-main) u-boot.lds FORCE
1772
	+$(call if_changed,u-boot__)
1773 1774
ifeq ($(CONFIG_KALLSYMS),y)
	$(call cmd,smap)
1775
	$(call cmd,u-boot__) common/system_map.o
1776
endif
W
wdenk 已提交
1777

R
Rick Chen 已提交
1778 1779 1780 1781
ifeq ($(CONFIG_RISCV),y)
	@tools/prelink-riscv $@ 0
endif

1782 1783 1784 1785 1786
quiet_cmd_sym ?= SYM     $@
      cmd_sym ?= $(OBJDUMP) -t $< > $@
u-boot.sym: u-boot FORCE
	$(call if_changed,sym)

M
Michal Simek 已提交
1787
# The actual objects are generated when descending,
1788 1789
# make sure no implicit rule kicks in
$(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1790

1791
# Handle descending into subdirectories listed in $(u-boot-dirs)
1792 1793 1794 1795
# Preset locale variables to speed up the build process. Limit locale
# tweaks to this spot to avoid wrong language settings when running
# make menuconfig etc.
# Error messages still appears in the original language
W
wdenk 已提交
1796

1797
PHONY += $(u-boot-dirs)
1798
$(u-boot-dirs): prepare scripts
1799 1800
	$(Q)$(MAKE) $(build)=$@

1801
tools: prepare
1802 1803 1804 1805 1806
# The "tools" are needed early
$(filter-out tools, $(u-boot-dirs)): tools
# The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
# is "yes"), so compile examples after U-Boot is compiled.
examples: $(filter-out examples, $(u-boot-dirs))
1807

1808 1809 1810 1811 1812
define filechk_uboot.release
	echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
endef

# Store (new) UBOOTRELEASE string in include/config/uboot.release
M
Masahiro Yamada 已提交
1813
include/config/uboot.release: include/config/auto.conf FORCE
1814 1815 1816
	$(call filechk,uboot.release)


1817 1818 1819 1820 1821 1822 1823 1824 1825 1826 1827 1828
# Things we need to do before we recursively start building the kernel
# or the modules are listed in "prepare".
# A multi level approach is used. prepareN is processed before prepareN-1.
# archprepare is used in arch Makefiles and when processed asm symlink,
# version.h and scripts_basic is processed / created.

# Listed in dependency order
PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3

# prepare3 is used to check if we are building in a separate output directory,
# and if so do:
# 1) Check that make has not been executed in the kernel src $(srctree)
1829
prepare3: include/config/uboot.release
1830
ifneq ($(KBUILD_SRC),)
M
Masahiro Yamada 已提交
1831 1832
	@$(kecho) '  Using $(srctree) as source for U-Boot'
	$(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1833 1834 1835 1836
		echo >&2 "  $(srctree) is not clean, please run 'make mrproper'"; \
		echo >&2 "  in the '$(srctree)' directory.";\
		/bin/false; \
	fi;
1837
endif
W
wdenk 已提交
1838

1839
# prepare2 creates a makefile if using a separate output directory
1840
prepare2: prepare3 outputmakefile cfg
1841

1842
prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) \
M
Masahiro Yamada 已提交
1843
                   include/config/auto.conf
1844 1845 1846 1847
ifeq ($(wildcard $(LDSCRIPT)),)
	@echo >&2 "  Could not find linker script."
	@/bin/false
endif
1848

1849 1850 1851 1852
ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
prepare1: $(defaultenv_h)
endif

1853 1854
archprepare: prepare1 scripts_basic

1855 1856
prepare0: archprepare FORCE
	$(Q)$(MAKE) $(build)=.
W
wdenk 已提交
1857

1858 1859
# All the preparing..
prepare: prepare0
W
wdenk 已提交
1860

1861 1862 1863
# Generate some files
# ---------------------------------------------------------------------------

S
Simon Glass 已提交
1864
# Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1865 1866 1867
define filechk_version.h
	(echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
	echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
S
Simon Glass 已提交
1868 1869 1870
	echo \#define U_BOOT_VERSION_NUM $(VERSION); \
	echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
		sed -e "s/^0*//"); \
1871 1872
	echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
	echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1873 1874
endef

1875 1876 1877 1878
# The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
# The BSD date on the other hand behaves different and would produce errors
# with the misused '-d' switch.  Respect that and search a working date with
# well known pre- and suffixes for the GNU variant of date.
1879
define filechk_timestamp.h
1880 1881
	(if test -n "$${SOURCE_DATE_EPOCH}"; then \
		SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1882 1883 1884 1885 1886 1887 1888 1889
		DATE=""; \
		for date in gdate date.gnu date; do \
			$${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
		done; \
		if test -n "$${DATE}"; then \
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
1890
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DMI_DATE "%m/%d/%Y"'; \
1891
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_BUILD_DATE 0x%Y%m%d'; \
1892
			LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
1893 1894 1895
		else \
			return 42; \
		fi; \
1896 1897 1898 1899
	else \
		LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
		LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
		LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
1900
		LC_ALL=C date +'#define U_BOOT_DMI_DATE "%m/%d/%Y"'; \
1901
		LC_ALL=C date +'#define U_BOOT_BUILD_DATE 0x%Y%m%d'; \
1902
		LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
1903
	fi)
1904 1905
endef

1906 1907 1908 1909
define filechk_defaultenv.h
	(grep -v '^#' | \
	 grep -v '^$$' | \
	 tr '\n' '\0' | \
1910
	 sed -e 's/\\\x0\s*//g' | \
1911 1912 1913
	 xxd -i ; echo ", 0x00" ; )
endef

1914 1915 1916 1917 1918 1919 1920 1921
define filechk_dt.h
	(if test -n "$${DEVICE_TREE}"; then \
		echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
	else \
		echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
	fi)
endef

1922
$(version_h): include/config/uboot.release FORCE
1923 1924 1925 1926 1927
	$(call filechk,version.h)

$(timestamp_h): $(srctree)/Makefile FORCE
	$(call filechk,timestamp.h)

1928 1929 1930
$(dt_h): $(srctree)/Makefile FORCE
	$(call filechk,dt.h)

1931 1932 1933
$(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
	$(call filechk,defaultenv.h)

1934
# ---------------------------------------------------------------------------
1935
quiet_cmd_cpp_lds = LDS     $@
1936
cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
1937
		-D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
1938

1939
u-boot.lds: $(LDSCRIPT) prepare FORCE
1940
	$(call if_changed_dep,cpp_lds)
1941

1942 1943
spl/u-boot-spl.bin: spl/u-boot-spl
	@:
1944 1945
	$(SPL_SIZE_CHECK)

1946 1947 1948 1949 1950 1951
spl/u-boot-spl-dtb.bin: spl/u-boot-spl
	@:

spl/u-boot-spl-dtb.hex: spl/u-boot-spl
	@:

1952
spl/u-boot-spl: tools prepare \
1953 1954
		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb) \
		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_TPL_OF_PLATDATA),dts/dt.dtb)
1955
	$(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
1956

1957 1958 1959
spl/sunxi-spl.bin: spl/u-boot-spl
	@:

1960 1961 1962
spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
	@:

1963
spl/u-boot-spl.sfp: spl/u-boot-spl
1964 1965
	@:

1966 1967 1968
spl/boot.bin: spl/u-boot-spl
	@:

1969
tpl/u-boot-tpl.bin: tools prepare \
1970
		$(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb)
M
Masahiro Yamada 已提交
1971
	$(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
S
Simon Glass 已提交
1972
	$(TPL_SIZE_CHECK)
1973

1974
TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
1975

1976 1977 1978
FIND := find
FINDFLAGS := -L

1979
tags ctags:
1980
		ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
L
Li Yang 已提交
1981
						-name '*.[chS]' -print`
1982
		ln -s ctags tags
W
wdenk 已提交
1983 1984

etags:
1985
		etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
L
Li Yang 已提交
1986
						-name '*.[chS]' -print`
L
Li Yang 已提交
1987
cscope:
1988 1989
		$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
						cscope.files
1990 1991 1992
		@find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
			grep -xvf - cscope.files > cscope.files.no-symlinks; \
		mv cscope.files.no-symlinks cscope.files
L
Li Yang 已提交
1993
		cscope -b -q -k
W
wdenk 已提交
1994

1995 1996
SYSTEM_MAP = \
		$(NM) $1 | \
W
wdenk 已提交
1997
		grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
1998
		LC_ALL=C sort
1999
System.map:	u-boot
M
Masahiro Yamada 已提交
2000
		@$(call SYSTEM_MAP,$<) > $@
W
wdenk 已提交
2001 2002 2003

#########################################################################

2004 2005
# ARM relocations should all be R_ARM_RELATIVE (32-bit) or
# R_AARCH64_RELATIVE (64-bit).
2006
checkarmreloc: u-boot
2007 2008 2009 2010 2011 2012 2013
	@RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
		grep R_A | sort -u`"; \
	if test "$$RELOC" != "R_ARM_RELATIVE" -a \
		 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
		echo "$< contains unexpected relocations: $$RELOC"; \
		false; \
	fi
2014

2015
tools/version.h: include/version.h
2016
	$(Q)mkdir -p $(dir $@)
2017 2018 2019
	$(call if_changed,copy)

envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2020
	$(Q)$(MAKE) $(build)=tools/env
M
Mike Frysinger 已提交
2021

2022
tools-only: export TOOLS_ONLY=y
2023
tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2024 2025
	$(Q)$(MAKE) $(build)=tools

M
Masahiro Yamada 已提交
2026
tools-all: export HOST_TOOLS_ALL=y
2027
tools-all: envtools tools ;
M
Mike Frysinger 已提交
2028

2029 2030 2031
cross_tools: export CROSS_BUILD_TOOLS=y
cross_tools: tools ;

2032 2033
.PHONY : CHANGELOG
CHANGELOG:
2034 2035
	git log --no-merges U-Boot-1_1_5.. | \
	unexpand -a | sed -e 's/\s\s*$$//' > $@
2036

W
wdenk 已提交
2037 2038
#########################################################################

2039 2040 2041 2042 2043 2044 2045 2046
###
# Cleaning is done on three levels.
# make clean     Delete most generated files
#                Leave enough to build external modules
# make mrproper  Delete the current configuration, and all generated files
# make distclean Remove editor backup files, patch leftover files and the like

# Directories & files removed with 'make clean'
M
Masahiro Yamada 已提交
2047 2048
CLEAN_DIRS  += $(MODVERDIR) \
	       $(foreach d, spl tpl, $(patsubst %,$d/%, \
M
Masahiro Yamada 已提交
2049
			$(filter-out include, $(shell ls -1 $d 2>/dev/null))))
M
Masahiro Yamada 已提交
2050

2051
CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h tools/version.h \
2052 2053
	       boot* u-boot* MLO* SPL System.map fit-dtb.blob* \
	       u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
2054
	       lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
2055
	       idbloader.img flash.bin flash.log defconfig
2056 2057

# Directories & files removed with 'make mrproper'
M
Masahiro Yamada 已提交
2058
MRPROPER_DIRS  += include/config include/generated spl tpl \
2059
		  .tmp_objdiff doc/output
M
Masahiro Yamada 已提交
2060
MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
2061 2062
		  ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
		  drivers/video/fonts/*.S
2063 2064 2065 2066 2067 2068

# clean - Delete most, but leave enough to build external modules
#
clean: rm-dirs  := $(CLEAN_DIRS)
clean: rm-files := $(CLEAN_FILES)

2069
clean-dirs	:= $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2070

T
Tom Rini 已提交
2071
clean-dirs      := $(addprefix _clean_, $(clean-dirs))
2072 2073 2074 2075 2076 2077 2078 2079 2080 2081

PHONY += $(clean-dirs) clean archclean
$(clean-dirs):
	$(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)

clean: $(clean-dirs)
	$(call cmd,rmdirs)
	$(call cmd,rmfiles)
	@find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
		\( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2082
		-o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2083
		-o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2084
		-o -name '*.lex.c' -o -name '*.tab.[ch]' \
2085
		-o -name '*.asn1.[ch]' \
2086 2087
		-o -name '*.symtypes' -o -name 'modules.order' \
		-o -name modules.builtin -o -name '.tmp_*.o.*' \
2088
		-o -name 'dsdt.aml' -o -name 'dsdt.asl.tmp' -o -name 'dsdt.c' \
2089
		-o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2090
		-type f -print | xargs rm -f
2091 2092 2093 2094 2095 2096

# mrproper - Delete all generated files, including .config
#
mrproper: rm-dirs  := $(wildcard $(MRPROPER_DIRS))
mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
mrproper-dirs      := $(addprefix _mrproper_,scripts)
W
wdenk 已提交
2097

2098 2099 2100 2101
PHONY += $(mrproper-dirs) mrproper archmrproper
$(mrproper-dirs):
	$(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)

M
Masahiro Yamada 已提交
2102
mrproper: clean $(mrproper-dirs)
2103 2104
	$(call cmd,rmdirs)
	$(call cmd,rmfiles)
2105
	@rm -f arch/*/include/asm/arch
2106 2107 2108 2109

# distclean
#
PHONY += distclean
2110 2111

distclean: mrproper
2112 2113 2114
	@find $(srctree) $(RCS_FIND_IGNORE) \
		\( -name '*.orig' -o -name '*.rej' -o -name '*~' \
		-o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2115 2116
		-o -name '.*.rej' -o -name '*%' -o -name 'core' \
		-o -name '*.pyc' \) \
2117
		-type f -print | xargs rm -f
2118
	@rm -f boards.cfg CHANGELOG
W
wdenk 已提交
2119 2120

backup:
2121
	F=`basename $(srctree)` ; cd .. ; \
2122
	gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
W
wdenk 已提交
2123

2124 2125
help:
	@echo  'Cleaning targets:'
M
Masahiro Yamada 已提交
2126
	@echo  '  clean		  - Remove most generated files but keep the config'
2127 2128 2129
	@echo  '  mrproper	  - Remove all generated files + config + various backup files'
	@echo  '  distclean	  - mrproper + remove editor backup and patch files'
	@echo  ''
M
Masahiro Yamada 已提交
2130 2131 2132
	@echo  'Configuration targets:'
	@$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
	@echo  ''
2133 2134 2135
	@echo  'Test targets:'
	@echo  ''
	@echo  '  check           - Run all automated tests that use sandbox'
2136
	@echo  '  qcheck          - Run quick automated tests that use sandbox'
2137
	@echo  '  tcheck          - Run quick automated tests on tools'
2138
	@echo  ''
2139 2140
	@echo  'Other generic targets:'
	@echo  '  all		  - Build all necessary images depending on configuration'
2141
	@echo  '  tests		  - Build U-Boot for sandbox and run tests'
2142
	@echo  '* u-boot	  - Build the bare u-boot'
2143 2144 2145 2146
	@echo  '  dir/            - Build all files in dir and below'
	@echo  '  dir/file.[oisS] - Build specified target only'
	@echo  '  dir/file.lst    - Build specified mixed source/assembly target only'
	@echo  '                    (requires a recent binutils and recent build (System.map))'
2147 2148
	@echo  '  tags/ctags	  - Generate ctags file for editors'
	@echo  '  etags		  - Generate etags file for editors'
2149
	@echo  '  cscope	  - Generate cscope index'
2150 2151
	@echo  '  ubootrelease	  - Output the release version string (use with make -s)'
	@echo  '  ubootversion	  - Output the version stored in Makefile (use with make -s)'
2152
	@echo  "  cfg		  - Don't build, just create the .cfg files"
2153
	@echo  "  envtools	  - Build only the target-side environment tools"
2154 2155 2156
	@echo  ''
	@echo  'Static analysers'
	@echo  '  checkstack      - Generate a list of stack hogs'
2157
	@echo  '  coccicheck      - Execute static code analysis with Coccinelle'
2158 2159
	@echo  ''
	@echo  'Documentation targets:'
2160
	@$(MAKE) -f $(srctree)/doc/Makefile dochelp
2161 2162 2163 2164 2165 2166 2167 2168 2169 2170 2171 2172 2173 2174 2175 2176
	@echo  ''
	@echo  '  make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
	@echo  '  make V=2   [targets] 2 => give reason for rebuild of target'
	@echo  '  make O=dir [targets] Locate all output files in "dir", including .config'
	@echo  '  make C=1   [targets] Check all c source with $$CHECK (sparse by default)'
	@echo  '  make C=2   [targets] Force check of all c source with $$CHECK'
	@echo  '  make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
	@echo  '  make W=n   [targets] Enable extra gcc checks, n=1,2,3 where'
	@echo  '		1: warnings which may be relevant and do not occur too often'
	@echo  '		2: warnings which occur quite often but may still be relevant'
	@echo  '		3: more obscure warnings, can most likely be ignored'
	@echo  '		Multiple levels can be combined with W=12 or W=123'
	@echo  ''
	@echo  'Execute "make" or "make all" to build all targets marked with [*] '
	@echo  'For further info see the ./README file'

2177
tests check:
2178
	$(srctree)/test/run
2179

2180 2181 2182
qcheck:
	$(srctree)/test/run quick

2183 2184 2185
tcheck:
	$(srctree)/test/run tools

2186 2187
# Documentation targets
# ---------------------------------------------------------------------------
2188 2189 2190 2191
DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
	       linkcheckdocs dochelp refcheckdocs
PHONY += $(DOC_TARGETS)
$(DOC_TARGETS): scripts_basic FORCE
2192
	$(Q)$(MAKE) $(build)=doc $@
2193

2194 2195 2196
endif #ifeq ($(config-targets),1)
endif #ifeq ($(mixed-targets),1)

2197 2198 2199 2200 2201 2202 2203 2204 2205 2206 2207 2208
PHONY += checkstack ubootrelease ubootversion

checkstack:
	$(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
	$(PERL) $(src)/scripts/checkstack.pl $(ARCH)

ubootrelease:
	@echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"

ubootversion:
	@echo $(UBOOTVERSION)

2209 2210 2211 2212 2213 2214 2215 2216 2217 2218 2219 2220 2221 2222 2223 2224 2225 2226 2227 2228 2229 2230 2231 2232 2233 2234 2235 2236 2237 2238 2239 2240 2241 2242 2243 2244 2245 2246 2247 2248 2249 2250 2251 2252 2253 2254 2255 2256 2257
# Single targets
# ---------------------------------------------------------------------------
# Single targets are compatible with:
# - build with mixed source and output
# - build with separate output dir 'make O=...'
# - external modules
#
#  target-dir => where to store outputfile
#  build-dir  => directory in kernel source tree to use

ifeq ($(KBUILD_EXTMOD),)
        build-dir  = $(patsubst %/,%,$(dir $@))
        target-dir = $(dir $@)
else
        zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
        build-dir  = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
        target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
endif

%.s: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.i: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.o: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.lst: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.s: %.S prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.o: %.S prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
%.symtypes: %.c prepare scripts FORCE
	$(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)

# Modules
/: prepare scripts FORCE
	$(cmd_crmodverdir)
	$(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
	$(build)=$(build-dir)
%/: prepare scripts FORCE
	$(cmd_crmodverdir)
	$(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
	$(build)=$(build-dir)
%.ko: prepare scripts FORCE
	$(cmd_crmodverdir)
	$(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1)   \
	$(build)=$(build-dir) $(@:.ko=.o)
	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost

2258 2259 2260 2261 2262 2263 2264
quiet_cmd_genenv = GENENV $@
cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
	sed --in-place -e 's/\x00/\x0A/g' $@

u-boot-initial-env: u-boot.bin
	$(call if_changed,genenv)

2265 2266 2267 2268 2269 2270 2271 2272
# Consistency checks
# ---------------------------------------------------------------------------

PHONY += coccicheck

coccicheck:
	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@

M
Michal Simek 已提交
2273
# FIXME Should go into a make.lib or something
2274 2275
# ===========================================================================

2276 2277 2278 2279 2280 2281
quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN   $(wildcard $(rm-dirs)))
      cmd_rmdirs = rm -rf $(rm-dirs)

quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN   $(wildcard $(rm-files)))
      cmd_rmfiles = rm -f $(rm-files)

2282 2283
# read all saved command lines

2284
cmd_files := $(wildcard .*.cmd $(foreach f,$(sort $(targets)),$(dir $(f)).$(notdir $(f)).cmd))
2285 2286 2287 2288 2289 2290

ifneq ($(cmd_files),)
  $(cmd_files): ;	# Do not try to update included dependency files
  include $(cmd_files)
endif

2291 2292 2293 2294 2295
endif	# skip-makefile

PHONY += FORCE
FORCE:

2296
# Declare the contents of the PHONY variable as phony.  We keep that
2297 2298
# information in a variable so we can use it in if_changed and friends.
.PHONY: $(PHONY)